var main_soc = {
};

var player = null;
var transfer = false;
var manager = false;
var timerService = null;

var service_timer = false;

$(document).ready(function(){
  try{
    if(!player){
      player = new PlayerController();
      $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
      player.init();
    }
  }catch(e){
    $("#starter").html("System in recovery mode.");
    console.log("Unable to start player");
    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.setTimeCallback = player.setUseServerTime;
          transfer.init(player.version);
      }
      transfer.activateLogger(player.debug);
      transfer.update(player.timestamp);
    }catch(e){
      console.log("Unable to start transfer");
    }
    
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      manager.activateLogger(player.debug);
      var scheduleConfig = player.config.getScheduleConfig();
      manager.update(scheduleConfig);
    }catch(e){
      console.log("Unable to start manager");
    }
    
  }
});

function onPlayerDataLoaded(){
    $("#starter").hide();
    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.setTimeCallback = player.setUseServerTime;
          transfer.init(player.version);
      }
      transfer.activateLogger(player.debug);
      transfer.update(player.timestamp);
    }catch(e){
      console.log("Unable to start transfer");
    }

    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      manager.activateLogger(player.debug);
      var scheduleConfig = player.config.getScheduleConfig();
      manager.update(scheduleConfig);
    }catch(e){
      console.log("Unable to start manager");
    }
    
    if(transfer.bundle == "0" || transfer.bundle.substring(0,2) == "\r"){
        transfer.log("transfer.bundle.subString(0,2): "+transfer.bundle.substring(0,2));
        transfer.OS.readFile(transfer.ROUTES['VER'].path,function(data,file_ref,params){
            transfer.log("Bundle data VER : "+data);
            if(data != ""){
                transfer.bundle = data;
            }else{
                transfer.log("Trying to read file : "+player.ROUTES['MANIFEST'].path);
                transfer.OS.readFile(transfer.ROUTES['MANIFEST'].path,function(data,file_ref,params){
                    transfer.log("Bundle data : "+data);
                    if(data != ""){
                        var parser=new DOMParser();
                        var xmlDoc=parser.parseFromString(data,"text/xml");
                        transfer.bundle = xmlDoc.getElementsByTagName("ver")[0].childNodes[0].nodeValue;
                    }
                });
            }
        });
    }

    setTimeout(function(){
        transfer.log("transfer.bundle.subString(0,2): "+transfer.bundle.substring(0,2));
        if(transfer.bundle == "0" || transfer.bundle.substring(0,2) == "\r\n"){
            $.ajax({
                url:"/mtd_down/common/HospitalityBrowser/admira.ver",
                dataType:'text',
                cache: false,
                success: function( data3 ) {
                    if(data3.length > 0){
                        transfer.log("Bundle data VER 5 con ajax: "+data3);
                        transfer.bundle = data3;
                    }
                },
                error: function(e){
                    transfer.log("Error con el ajax de bundle");
                    transfer.OS.readFile("admira.ver",function(data4,file_ref,params){
                        if(data4 != "" && data4.length > 0){
                            transfer.log("Bundle data con readfile: "+data4);
                            transfer.bundle = data4;
                        }
                        else{
                            transfer.log("Error con el readfile de bundle");
                        }
                    })
                }
            });
        }
        transfer.OS.existsLIC();
        transfer.OS.existsCORE();
        transfer.OS.existsXMLS();
    },10000);

    setTimeout(function(){
      if(!timerService){
        timerService = new TimerService();
      }
      timerService.checkTimers(scheduleConfig);
    }, 15000);

    if(!service_timer){
        service_timer = setInterval(service,10000);
    }
}

function service(){
    if(player){
      player.service();
      try{
        if(transfer){
            transfer.updateInfo(player.name,player.getInfo());
        }
      }catch(e){
        console.log("Unable to update player info for transfer");
      }
    }
}

function onKeyTV(){
    var keyCode = event.keyCode;
    switch (keyCode) {
        case player.OS.TV.KEY_LEFT:
            player.playlist.jump(-1);
            break;
        case player.OS.TV.KEY_RIGHT:
            player.playlist.jump();
            break;
        case player.OS.TV.KEY_0:
            player.debug = !player.debug;
            try{
              player.setLogger($("#playerLog"));
              player.activateLogger(player.debug);
            }catch(e){
              console.log("Error on player toggle debug");
            }
            try{
              transfer.setLogger($("#transferLog"));
              transfer.activateLogger(player.debug);
              manager.setLogger($("#transferLog"));
            }catch(e){
              console.log("Error on transfer toggle debug");
            }
            break;
        case player.OS.TV.KEY_DOWN:
            break;
        case player.OS.TV.KEY_1:
  					player.toggleCoreSetupWindow();
  					break;
        /*
        case player.OS.TV.KEY_2:
            player.toggleProxySetupWindow();
            break;
        */
        case player.OS.TV.KEY_PANEL_ENTER:
            //player.update();
            break;
        default:
            player.log("TV : Unhandled key");
            break;
    }
}
